--
-- growthcontrol
-- V17.0
--
-- @author apuehri
-- @date 28/11/2016
--
-- Copyright (C) apuehri
-- V17.0 ..... first implementation
-- V17.1 ..... recalculate after saving

growthcontrol = {};
growthcontrol.Version = 17.1;

function growthcontrol.prerequisitesPresent(specializations)
    return true;
end;

function growthcontrol:loadMap(name)
	--initialize
	growthcontrol.showHud = false;
	growthcontrol.recalculate = false;
	growthcontrol.maxnumfruits = 11;
	growthcontrol.fruitnames = {[0]="wheat",[1]="grass",[2]="rape",[3]="barley",[4]="maize",[5]="not used",[6]="potato",[7]="sugarBeet",[8]="sunflower",[9]="soybean",[10]="oilseedRadish",[11]="poplar"};
	growthcontrol.growthhours = {[0]=24,[1]=22,[2]=24,[3]=24,[4]=24,[5]=0,[6]=24,[7]=24,[8]=24,[9]=24,[10]=20,[11]=35};	
	growthcontrol.growthstatetime = {};
	growthcontrol.growthremtime = {};
	
	-- Hud
	growthcontrol.tPos = {};
	growthcontrol.tPos.x = 0.798;											-- x Pos
	growthcontrol.tPos.y = 0.892;											-- y Pos
	growthcontrol.tPos.size = 0.015;										-- TextSize
	growthcontrol.tPos.spacing = 0.003;									-- Spacing
	growthcontrol.tPos.alignment = RenderText.ALIGN_LEFT;			-- Text Alignment	
	
	g_currentMission.environment:addMinuteChangeListener(growthcontrol);
	
	--load Savegame
	local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	end;

	if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
		if fileExists(savegameFolderPath .. '/growthcontrol.xml') then
			print("--- loading growthcontrol V"..string.format("%1.2f",growthcontrol.Version).." (c) by aPuehri --- loading savegame ---");
			local key = "growthcontrol";
			local xmlFile = loadXMLFile("growthcontrol", savegameFolderPath .. "/growthcontrol.xml", key);
				if xmlFile ~= nil then
					for i=0, growthcontrol.maxnumfruits do
						growthcontrol.growthhours[i] = getXMLFloat(xmlFile, "growthcontrol.fruit("..i..")#hours");
						growthcontrol.growthstatetime[i] = growthcontrol.growthhours[i]*3.6e6;
						local frname = growthcontrol.fruitnames[i];
						if (frname ~= nil) and (frname ~= "not used") then
							FruitUtil.fruitTypeGrowths[frname].growthStateTime = growthcontrol.growthstatetime[i];
						end;
					end;				
				end;
			delete(xmlFile);
		else
			print("--- loading growthcontrol V"..string.format("%1.2f",growthcontrol.Version).." (c) by aPuehri --- loading initialvalues ---");
			for i=0, growthcontrol.maxnumfruits do
				growthcontrol.growthstatetime[i] = growthcontrol.growthhours[i]*3.6e6;
				local frname = growthcontrol.fruitnames[i];
				if (frname ~= nil) and (frname ~= "not used") then
					FruitUtil.fruitTypeGrowths[frname].growthStateTime = growthcontrol.growthstatetime[i];
				end;
			end;			
		end;

		--read values of fruit_density_growthState.xml and calculate remaining growthtime in minutes
		if fileExists(savegameFolderPath .. '/fruit_density_growthState.xml') then
			local key = "foliageCropsUpdater";
			local xmlFile = loadXMLFile("fruit_density_growthState", savegameFolderPath .. "/fruit_density_growthState.xml", key);
			for i=0, growthcontrol.maxnumfruits do
				growthcontrol.growthremtime[i] = getXMLFloat(xmlFile, "foliageCropsUpdater.cropsState("..i..")#normalizedGrowthTimer");				
				if growthcontrol.growthremtime[i] == nil then
					growthcontrol.growthremtime[i] = 1;
				end;
				growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
				print("---     Remaining Time["..growthcontrol.fruitnames[i].."]: = "..(growthcontrol.growthremtime[i]/60).." hours ---");
			end;
			delete(xmlFile);						
		end;		
	else
		print("--- loading growthcontrol V"..string.format("%1.2f",growthcontrol.Version).." (c) by aPuehri --- loading initialvalues ---");
		for i=0, growthcontrol.maxnumfruits do
			growthcontrol.growthstatetime[i] = growthcontrol.growthhours[i]*3.6e6;
			local frname = growthcontrol.fruitnames[i];
			if (frname ~= nil) and (frname ~= "not used") then
				FruitUtil.fruitTypeGrowths[frname].growthStateTime = growthcontrol.growthstatetime[i];
			end;
			growthcontrol.growthremtime[i] = 1;			
			growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
			print("---     Remaining Time["..growthcontrol.fruitnames[i].."]: = "..(growthcontrol.growthremtime[i]/60).." hours ---");			
		end;		
	end;
	
end;

function growthcontrol:deleteMap()
	growthcontrol.showHud = false;
	growthcontrol.recalculate = false;
end

function growthcontrol:mouseEvent(posX, posY, isDown, isUp, button)
end;

function growthcontrol:keyEvent(unicode, sym, modifier, isDown)
end;

function growthcontrol:update(dt)
	g_currentMission:setPlantGrowthRate(3,nil); --growthRate to normal
	g_currentMission:setPlantGrowthRateLocked(true); --lock growthRate Selection
	
	--showHud
	if InputBinding.hasEvent(InputBinding.gc_ToggleHud) then
		if not g_currentMission.isPaused and not growthcontrol.showHud then
			growthcontrol.showHud = true;
		elseif growthcontrol.showHud then
			growthcontrol.showHud = false;
		end;
	end;
	
	--check recalculation
	if not g_currentMission.isSaving and growthcontrol.recalculate then
		--print("--- growthcontrol initialized recalculation ---");
		--load Savegame
		local savegameIndex = g_currentMission.missionInfo.savegameIndex;
		local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
		if savegameFolderPath == nil then
			savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
		end;

		if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
			--read values of fruit_density_growthState.xml and calculate remaining growthtime in minutes
			if fileExists(savegameFolderPath .. '/fruit_density_growthState.xml') then
				local key = "foliageCropsUpdater";
				local xmlFile = loadXMLFile("fruit_density_growthState", savegameFolderPath .. "/fruit_density_growthState.xml", key);
				for i=0, growthcontrol.maxnumfruits do
					growthcontrol.growthremtime[i] = getXMLFloat(xmlFile, "foliageCropsUpdater.cropsState("..i..")#normalizedGrowthTimer");				
					if growthcontrol.growthremtime[i] == nil then
						growthcontrol.growthremtime[i] = 1;
					end;
					growthcontrol.growthremtime[i] = (growthcontrol.growthremtime[i] * growthcontrol.growthstatetime[i]) / 60000;
					--print("--- recalculated Remaining Time["..growthcontrol.fruitnames[i].."]: = "..(growthcontrol.growthremtime[i]/60).." hours ---");
				end;
				delete(xmlFile);
				growthcontrol.recalculate = false;
			end;		
		end;	
	end;
end

function growthcontrol:draw()
	if g_currentMission.isPaused or g_gui.currentGui ~= nil or not growthcontrol.showHud then
		return;
	end;
	
	local uiScale = Utils.getUIScaleFromIndex(g_settingsScreen.defaultSettings.uiScale.current);
	local textheight = growthcontrol.tPos.size * uiScale;
	
	setTextColor(1,1,1,1);

	setTextAlignment(growthcontrol.tPos.alignment);
	setTextBold(true);
	renderText(growthcontrol.tPos.x, growthcontrol.tPos.y, textheight , g_i18n:getText('growthstate'));
	setTextBold(false);
	local yPos = growthcontrol.tPos.y - growthcontrol.tPos.size - growthcontrol.tPos.spacing;
   for i=0, growthcontrol.maxnumfruits do
		if (growthcontrol.fruitnames[i] ~= nil) and (growthcontrol.fruitnames[i] ~= "not used") then
			local frname = FruitUtil.fillTypeToFruitType[growthcontrol.fruitnames[i]];			
			renderText(growthcontrol.tPos.x, yPos, textheight , g_i18n:getText(growthcontrol.fruitnames[i]).." = "..(string.format("%.4f",growthcontrol.growthremtime[i]/60)).." "..g_i18n:getText('growthhour'));
			yPos = yPos - growthcontrol.tPos.size - growthcontrol.tPos.spacing;
		end;	
	end;	
end;

function growthcontrol:minuteChanged()
	for i=0, growthcontrol.maxnumfruits do
	   if (growthcontrol.growthremtime[i] > 0) then
			growthcontrol.growthremtime[i] = growthcontrol.growthremtime[i]-1;	
			--print("--- Restzeit Wachstum["..growthcontrol.fruitnames[i].."]: = "..(growthcontrol.growthremtime[i]/60).." Stunden ---");
		else
			growthcontrol.growthremtime[i] = growthcontrol.growthstatetime[i] / 60000;
		end;
	end;	
end;

function growthcontrol:saveSettings()
	local savegameIndex = g_currentMission.missionInfo.savegameIndex;
	local savegameFolderPath = g_currentMission.missionInfo.savegameDirectory;
	if savegameFolderPath == nil then
		savegameFolderPath = ('%ssavegame%d'):format(getUserProfileAppPath(), savegameIndex);
	end;
	
	if fileExists(savegameFolderPath .. '/careerSavegame.xml') then
		local key = "growthcontrol"; 
		local xmlFile = createXMLFile("growthcontrol", savegameFolderPath .. "/growthcontrol.xml", key);
			
		for i=0, growthcontrol.maxnumfruits do
			setXMLString(xmlFile, "growthcontrol.fruit("..i..")#name",growthcontrol.fruitnames[i]);
			setXMLFloat(xmlFile, "growthcontrol.fruit("..i..")#hours",growthcontrol.growthhours[i]);
		end;
		saveXMLFile(xmlFile);
		delete(xmlFile);		
	end;
	growthcontrol.recalculate = true;
end;
g_careerScreen.saveSavegame = Utils.appendedFunction(g_careerScreen.saveSavegame, growthcontrol.saveSettings);

addModEventListener(growthcontrol);